#ifndef REGST4X_H_
#define REGST4X_H_

typedef enum
{
    tccr0b_clkdiv_off = (0<<CS02) | (0<<CS01) | (0<<CS00),
    tccr0b_clkdiv_1 = (0<<CS02) | (0<<CS01) | (1<<CS00),
    tccr0b_clkdiv_8 = (0<<CS02) | (1<<CS01) | (0<<CS00),
    tccr0b_clkdiv_64 = (0<<CS02) | (1<<CS01) | (1<<CS00),
    tccr0b_clkdiv_256 = (1<<CS02) | (0<<CS01) | (0<<CS00),
    tccr0b_clkdiv_1024 = (1<<CS02) | (0<<CS01) | (1<<CS00),
    tccr0b_clkdiv_extT0f = (1<<CS02) | (1<<CS01) | (0<<CS00),
    tccr0b_clkdiv_extT0r = (1<<CS02) | (1<<CS01) | (1<<CS00),
}   tccr0b_clkdiv_t;

typedef enum
{
    tccr0a_wgm_normal = (0<<WGM01) | (0<<WGM00),
    tccr0a_wgm_pwmPC = (0<<WGM01) | (1<<WGM00),
    tccr0a_wgm_ctc = (1<<WGM01) | (0<<WGM00),
    tccr0a_wgm_fastPwm = (1<<WGM01) | (1<<WGM00),
    tccr0a_wgm_Reserved0 = (0<<WGM01) | (0<<WGM00),
    tccr0a_wgm_pwmPCBot = (0<<WGM01) | (1<<WGM00),
    tccr0a_wgm_Reserved1 = (1<<WGM01) | (0<<WGM00),
    tccr0a_wgm_fastPwmOcrA = (1<<WGM01) | (1<<WGM00),
}   tccr0a_wgm_t;

typedef enum
{
    tccr0b_wgm_normal = (0<<WGM02),
    tccr0b_wgm_pwmPC = (0<<WGM02),
    tccr0b_wgm_ctc = (0<<WGM02),
    tccr0b_wgm_fastPwm = (0<<WGM02),
    tccr0b_wgm_Reserved0 = (1<<WGM02),
    tccr0b_wgm_pwmPCBot = (1<<WGM02),
    tccr0b_wgm_Reserved1 = (1<<WGM02),
    tccr0b_wgm_fastPwmOcrA = (1<<WGM02),
}   tccr0b_wgm_t;

typedef enum
{
    tccr0_wgm_normal = (0<<WGM02) | (0<<WGM01) | (0<<WGM00),
    tccr0_wgm_pwmPC = (0<<WGM02) | (0<<WGM01) | (1<<WGM00),
    tccr0_wgm_ctc = (0<<WGM02) | (1<<WGM01) | (0<<WGM00),
    tccr0_wgm_fastPwm = (0<<WGM02) | (1<<WGM01) | (1<<WGM00),
    tccr0_wgm_Reserved0 = (1<<WGM02) | (0<<WGM01) | (0<<WGM00),
    tccr0_wgm_pwmPCBot = (1<<WGM02) | (0<<WGM01) | (1<<WGM00),
    tccr0_wgm_Reserved1 = (1<<WGM02) | (1<<WGM01) | (0<<WGM00),
    tccr0_wgm_fastPwmOcrA = (1<<WGM02) | (1<<WGM01) | (1<<WGM00),
}   tccr0_wgm_t;

#define tccr0a_wgm(a) (a & ((1<<WGM01) | (1<<WGM00)))
#define tccr0b_wgm(a) (a & (1<<WGM02))

//timer 1 in tiny15-mode
typedef enum
{
    tccr1t15_clkdiv_off    = (0<<CS13) | (0<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_PCK1   = (0<<CS13) | (0<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_PCK2   = (0<<CS13) | (0<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_PCK4   = (0<<CS13) | (0<<CS12) | (1<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_PCK8   = (0<<CS13) | (1<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_CK1    = (0<<CS13) | (1<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_CK2    = (0<<CS13) | (1<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_CK4    = (0<<CS13) | (1<<CS12) | (1<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_CK8    = (1<<CS13) | (0<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_CK16   = (1<<CS13) | (0<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_CK32   = (1<<CS13) | (0<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_CK64   = (1<<CS13) | (0<<CS12) | (1<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_CK128  = (1<<CS13) | (1<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_CK256  = (1<<CS13) | (1<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1t15_clkdiv_CK512  = (1<<CS13) | (1<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1t15_clkdiv_CK1024 = (1<<CS13) | (1<<CS12) | (1<<CS11) | (1<<CS10),
    
}   tccr1t15_clkdiv_t;

typedef enum
{
    tccr1_clkdiv_off   = (0<<CS13) | (0<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1_clkdiv_1     = (0<<CS13) | (0<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1_clkdiv_2     = (0<<CS13) | (0<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1_clkdiv_4     = (0<<CS13) | (0<<CS12) | (1<<CS11) | (1<<CS10),
    tccr1_clkdiv_8     = (0<<CS13) | (1<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1_clkdiv_16    = (0<<CS13) | (1<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1_clkdiv_32    = (0<<CS13) | (1<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1_clkdiv_64    = (0<<CS13) | (1<<CS12) | (1<<CS11) | (1<<CS10),
    tccr1_clkdiv_128   = (1<<CS13) | (0<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1_clkdiv_256   = (1<<CS13) | (0<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1_clkdiv_512   = (1<<CS13) | (0<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1_clkdiv_1024  = (1<<CS13) | (0<<CS12) | (1<<CS11) | (1<<CS10),
    tccr1_clkdiv_2048  = (1<<CS13) | (1<<CS12) | (0<<CS11) | (0<<CS10),
    tccr1_clkdiv_4096  = (1<<CS13) | (1<<CS12) | (0<<CS11) | (1<<CS10),
    tccr1_clkdiv_8192  = (1<<CS13) | (1<<CS12) | (1<<CS11) | (0<<CS10),
    tccr1_clkdiv_16384 = (1<<CS13) | (1<<CS12) | (1<<CS11) | (1<<CS10),
    
}   tccr1_clkdiv_t;

#endif /* REGST4X_H_ */