from keyboardconverter import KeycodeConverter_de
from footswitch import Footswitch, FootswitchException, FootswitchSequence

text = 'http://hobbyelektronik.org\n'

keycodes = KeycodeConverter_de.string_to_keycodes(text)
commands = FootswitchSequence.keycodes_to_commands(keycodes)

print('Text:', text)
print('Keycodes:', keycodes)

if len(commands) > 128:
    print('Command sequence too long, must be <= 128, is %u' % len(commands))
    exit()
else:
    print('Sequence length: %u' % len(commands))
    print('Commands:', '[0x' + (', 0x'.join('{:02x}'.format(x).upper() for x in commands)) + ']')

footsie = None
try:
    footsie = Footswitch()
except FootswitchException:
    print("Footswitch could not be found, is it in config mode?")
    print("Press the button while plugging the USB cable")
    exit()

footsie.set_kbseq(commands)